// ------------------------------------------------------------------------------------------ //
//                     B D F X T R E N D E R   I N D I C A T O R                              //
//                          by fosgate_r     January 2009                                    //
//                      URL : http://forexfreeea.blogspot.com/                                //
// ------------------------------------------------------------------------------------------ //


#property copyright " January 2009 fosgate_r"
#property link "http://forexfreeea.blogspot.com/"
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Gold
#property indicator_color2 Blue
#property indicator_color3 Red


// ------------------------------------------------------------------------------------------ //
//                            I N T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double Space1[], Space2[], Space3[], Space4[], Space5[], trend[], B2;
int    Count = 100, Vx1,Vx2 ,i;


// ------------------------------------------------------------------------------------------ //
//                             I N I T I A L I S A T I O N                                    //
// ------------------------------------------------------------------------------------------ //

int init()
{
   IndicatorBuffers (6);
   SetIndexBuffer (2,Space1);
   SetIndexBuffer (1,Space2);
   SetIndexBuffer (0,Space3);
   SetIndexBuffer (3,Space4);
   SetIndexBuffer (4,Space5);
   SetIndexBuffer (5,trend);
   SetIndexStyle  (2,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle  (1,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle  (0,DRAW_HISTOGRAM,STYLE_SOLID,2);
   return(0);
}


// ------------------------------------------------------------------------------------------ //
//                                M A I N   P R O C E D U R E                                 //
// ------------------------------------------------------------------------------------------ //

int start()
{
   Vx1 = Count;
   i   = ((((Bars-Count)-5)-Vx1)-1);

   while (i >= 0) 
   {
      Space4[1] = 0;
      Vx2       = Vx1;
      while (Vx2 >= 1) 
      {
         Space4[1] = (Space4[1] + ((Vx2-((Vx1+1)*0.333333)) * Close[((Vx1-Vx2)+i)]));
         Vx2       = Vx2-1;
      }

      Space5[i] = ((Space4[1]*6)/(Vx1*(Vx1+1)));
      B2        = iMA(0,0,7,0,MODE_EMA,PRICE_TYPICAL,i);
      trend[i]  = trend[i+1];
      Space3[i] = Space5[i];
      Space2[i] = Space5[i];
      Space1[i] = Space5[i];
      
      if (((Space5[(i+1)]>Space5[i]) && (Space5[i]>B2)) == 1)  { Space2[i] = EMPTY_VALUE; trend[i] =-1; }
      else 
      {  if (((Space5[(i+1)]<Space5[i]) && (Space5[i]<B2))==1) { Space1[i] = EMPTY_VALUE; trend[i] = 1; }
         else  {  Space1[i] = EMPTY_VALUE; Space2[i] = EMPTY_VALUE;  }
      }
      i = i-1;
   }
   
   if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;
        if (trend[whichBar] != trend[whichBar+1])
        if (trend[whichBar] == 1)
              doAlert("up candle");
        else  doAlert("down candle");       
     }
return(0);
}

//
//
//
//
//

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," BDFXtrender ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," BDFXtrender "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}
      

// ------------------------------------------------------------------------------------------ //
//                               E N D   O F   I N D I C A T O R                              //
// ------------------------------------------------------------------------------------------ //

